-- status register handling 


LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE IEEE.std_logic_unsigned.ALL;

ENTITY status_regs IS

  PORT
    (
      clk           		: IN STD_LOGIC;
      reset         		: IN STD_LOGIC;
      statusRd				: IN STD_LOGIC;
      captureData   		: IN STD_LOGIC_VECTOR(7 DOWNTO 0);
      address   			: IN STD_LOGIC_VECTOR(7 DOWNTO 0);
      statusReg     		: IN  STD_LOGIC_VECTOR(63 DOWNTO 0);
      dataOut				: OUT STD_LOGIC_VECTOR(7 DOWNTO 0)

      );
							
END status_regs;

ARCHITECTURE rtl OF status_regs IS

BEGIN

dataOut <=        statusReg(7 DOWNTO 0)   WHEN address  = x"00" AND statusRd = '1'
             ELSE statusReg(15 DOWNTO 8)  WHEN address  = x"01" AND statusRd = '1'
             ELSE statusReg(23 DOWNTO 16) WHEN address  = x"02" AND statusRd = '1'
             ELSE statusReg(31 DOWNTO 24) WHEN address  = x"03" AND statusRd = '1'
             ELSE statusReg(39 DOWNTO 32) WHEN address  = x"04" AND statusRd = '1'
             ELSE statusReg(47 DOWNTO 40) WHEN address  = x"05" AND statusRd = '1'
             ELSE statusReg(55 DOWNTO 48) WHEN address  = x"06" AND statusRd = '1'
             ELSE statusReg(63 DOWNTO 56) WHEN address  = x"07" AND statusRd = '1'
             ELSE captureData             WHEN address  = x"08" AND statusRd = '1'
             ELSE X"AA";
END rtl;





