-- USB bus tristate control
-- 


LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE IEEE.std_logic_unsigned.ALL;


ENTITY tristate IS

PORT
(
	reset					: IN	STD_LOGIC;
	clk						: IN	STD_LOGIC;
	wr						: IN	STD_LOGIC;
	dataIn					: OUT	STD_LOGIC_VECTOR( 7 DOWNTO 0);
	dataOut					: IN	STD_LOGIC_VECTOR( 7 DOWNTO 0);

	extUsbBus				: INOUT	STD_LOGIC_VECTOR( 7 DOWNTO 0)

);

end tristate;

ARCHITECTURE rtl OF tristate IS
-- bi directional bus control
-- latches data into the device on the falling edge of rd
BEGIN
	PROCESS ( extUsbBus, reset,clk)
	BEGIN
		IF ( RESET ='1' ) THEN 
				dataIn <= ( OTHERS =>'0');

	    ELSIF ( rising_edge ( clk ) ) THEN 
				    dataIn <= extUsbBus;
		 END IF;
	END PROCESS;

 -- data_bus_out:
	extUsbBus <= dataOut WHEN wr = '1'
			ELSE ( OTHERS => 'Z');

END rtl;



