-- contains a 32 bit downcounter

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE IEEE.std_logic_unsigned.ALL;

ENTITY downcounter IS
	GENERIC
	(
		size			: NATURAL := 7 
	);
	PORT
	(	
		clk	  			: IN  STD_LOGIC;
		clken	  		: IN  STD_LOGIC;
		reset	  		: IN  STD_LOGIC;
		enable			: IN  STD_LOGIC;
		count			: IN  STD_LOGIC_VECTOR(size -1 DOWNTO 0);
		done			: OUT STD_LOGIC
	);

END downcounter;

ARCHITECTURE rtl OF downcounter IS


----------------------
-- Declare Signals  --
----------------------
 	SIGNAL counter			: STD_LOGIC_VECTOR ( size -1 DOWNTO 0);
----------------------
-- Code Starts Here --
----------------------

BEGIN
	PROCESS ( reset,clk,count,enable )
	BEGIN
		IF ( reset ='1' ) THEN
			counter <= count;
			done <= '0';
		ELSIF ( rising_edge( clk)) THEN
			IF ( enable ='1' )THEN
				IF ( clken ='1') THEN
					IF ( counter > 0 ) THEN
						counter <= counter -1;
						done <= '0';
					ELSE
						done <= '1';					
					END IF;
				END IF;
			ELSE
				counter <= count;
				done <= '0';
			END IF;			
		END IF;
	END PROCESS;
END rtl;




















