-- contains an edge detector

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE IEEE.std_logic_unsigned.ALL;

ENTITY edge_detector IS

	PORT
	(	
		clk	  			: IN  STD_LOGIC;
		input			: IN  STD_LOGIC;
		reset			: IN  STD_LOGIC;
		rising			: OUT  STD_LOGIC;
		falling			: OUT  STD_LOGIC
	);

END edge_detector;

ARCHITECTURE rtl OF edge_detector IS

	TYPE edge_states IS 
	(
		s_low,s_high,s_going_low, s_going_high
	);
	SIGNAL edge_state		: edge_states;

----------------------
-- Declare Signals  --
----------------------
 	SIGNAL edge			: STD_LOGIC_VECTOR ( 3 DOWNTO 0);
----------------------
-- Code Starts Here --
----------------------

BEGIN
l_filter:	PROCESS ( reset,clk,input )
BEGIN
	IF ( reset ='1' ) THEN
		edge <= "0000";
	ELSIF ( rising_edge( clk)) THEN
		edge(3)  <= edge(2);
		edge(2)  <= edge(1);
		edge(1)  <= edge(0);
		edge(0)  <= input;
	END IF;
END PROCESS;

l_edge:PROCESS( reset,clk,edge)
BEGIN
	IF ( reset ='1' ) THEN
		rising <= '0';
		falling <= '0';
		edge_state <= s_low;
	ELSIF ( rising_edge(clk)) THEN
		CASE edge_state IS
			WHEN s_low =>
				rising <= '0';
				falling <= '0';
				IF ( edge = "1111") THEN
					edge_state <= s_going_high;
				END IF;

			WHEN s_going_high =>
				rising <= '1';
				falling <= '0';
				edge_state <= s_high;
				
			WHEN s_high =>
				rising <= '0';
				falling <= '0';
				IF ( edge = "0000") THEN
					edge_state <= s_going_low;
				END IF;

			WHEN s_going_low =>
				rising <= '0';
				falling <= '1';
				edge_state <= s_low;
		END CASE;
	END IF;
END PROCESS;






END rtl;




















