-- contains clock prescaler


LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE IEEE.std_logic_unsigned.ALL;

ENTITY prescaler IS

	PORT
	(	
		clk	  		: IN  STD_LOGIC;
		reset			: IN  STD_LOGIC;
		prescale		: OUT  STD_LOGIC_VECTOR(7 DOWNTO 0)
	);

END prescaler;

ARCHITECTURE rtl OF prescaler IS


----------------------
-- Declare Signals  --
----------------------
 	SIGNAL accumulator		: STD_LOGIC_VECTOR ( 35 DOWNTO 0);
 	SIGNAL edge_finder		: STD_LOGIC_VECTOR ( 3 DOWNTO 0);
----------------------
-- Code Starts Here --
----------------------

BEGIN

	PROCESS ( reset,clk )
	BEGIN
		IF ( reset ='1' ) THEN
			prescale <= x"00";
			edge <='0';
		ELSIF ( rising_edge( clk)) THEN
			accumulator <= accumulator + phase;
			edge_finder <= edge_finder(3 DOWNTO 1 ) & accumulator(35);
			IF ( edge_finder ="0011") THEN
				edge <='1';
			ELSE
				edge <='0';
			END IF;
		END IF
	END PROCESS;
	
	ncoOut <= accumulator(35);

END rtl;




















